(function() {

    owner = {};
	owner.isArray = function(obj) {
		return Object.prototype.toString.call(obj) === '[object Array]';
	};

	String.prototype.endWith = function(endStr) {
		console.log(endStr);
		if (Object.prototype.toString.call(endStr) === '[object Array]') {
			for (var i = 0; i < endStr.length; i++) {
				var endstring = endStr[i];
				var d = this.length - endstring.length;
				return (d >= 0 && this.lastIndexOf(endstring) == d);
			}
		} else {
			var d = this.length - endStr.length;
			return (d >= 0 && this.lastIndexOf(endStr) == d);
		}
	};

	/*
	 * 使用tagName、className双重检索。
	 */
	owner.getElementByClassNameAndTagName = function(tagName, className) {
			var tags = document.getElementsByTagName(tagName);
			var tagArr = [];
			for (var i = 0; i < tags.length; i++) {

				if (tags[i].className == className || className.length == 0) {
					tagArr[tagArr.length] = tags[i];
				}
			}
			return tagArr;
	};

	/*
	 * 遍历documentNode下所有TagName，找到以后调用callback
	 */
	owner.loop1 = function(documentNode, tagName, callback) {
		var result = "";
		var childs = documentNode.childNodes;
		for (var i = 0; i < childs.length; i++) {
			if (childs[i].nodeType != 1) continue;
			if (childs[i].nodeType == 1 && (childs[i].tagName.toLowerCase() == tagName || tagName.length == 0)) {
				if (typeof(callback) == "function") {
					var finded = callback(childs[i]);
					if (finded)
						result += finded;
				}
			}
		}
		return result;
	};
	/*
	 * 判断这个节点下是否存在指定属性的节点
	 */
	owner.isExistsNode = function(pNode, idName, className) {
		var childs = pNode.childNodes;
		for (var i = 0; i < childs.length; i++) {
			if (childs[i].nodeType != 1) continue;
			if ((typeof(idName) == "string" && idName.length > 0) || owner.isArray(idName)) {
				var idNames = typeof(idName) == "string" ? [idName] : idName;
				for (var j = 0; j < idNames.length; j++) {
					if (typeof(childs[i].id) != "undefined" && childs[i].id.toLowerCase() == idNames[j])
						return true;
				}
			}
			if ((typeof(className) == "string" && className.length > 0) || owner.isArray(className)) {
				var classNames = typeof(className) == "string" ? [className] : className;
				for (var j = 0; j < classNames.length; j++) {
					if (typeof(childs[i].className) != "undefined" && childs[i].className.toLowerCase() == classNames[j])
						return true;
				}
			}
		}
		return false;
	};

	/*
	 * 模板1，获取文章=>
	 * 1.找到div，class = "wm-container wemedia"
	 * 2.遍历找到的节点，找到tagName =  contentTagName,classname = contentName
	 */
	owner.template1 = (function(tagName, className, contentTagName, contentName) {
		var container = owner.getElementByClassNameAndTagName(tagName, className);
		if (container.length > 0) {
			if (owner.isExistsNode(container[0], "", contentName)) {
				console.log("模板1适用");
				try {
					var author = document.getElementsByClassName("article-wmname");
					if (author && author.length >0) {
						owner.author = author[0].innerText;
					}
					var descriptions = owner.getElementByTagNameAndName("meta", "description");
					if (descriptions && descriptions.length > 0)
						owner.description = descriptions[0].content;
					var titles = document.getElementsByTagName("title");
					if (titles && titles.length > 0)
						owner.title = titles[0].innerText;
				} catch (e) {

				}
				return owner.loop1(container[0], contentTagName, function(docEle) {
					if ((typeof(contentName) == "string" && docEle.className != contentName) || (owner.isArray(contentName) && contentName.indexOf(docEle.className) == -1)) {
						docEle.style = "display:none;"
					} else return docEle.outerHTML;
				});
			} else {
			    console.log("模板1不适用");
			}
		} else{
		    console.log("模板1不适用");
		}
		return "";

	})("div", "wm-container wemedia", "div", "contentbox");

	/*
	 *模板二 
	 */
	owner.template2 = (function(tagName, className, contentTagName, contentName) {
	    if (owner.template1.length > 0) return owner.template1;

		var container = owner.getElementByClassNameAndTagName(tagName, className);

		if (container.length > 0) {
			if (owner.isExistsNode(container[0], "", contentName)) {
				console.log("模板2适用");
				return owner.loop1(container[0], contentTagName, function(docEle) {
					if ((typeof(contentName) == "string" && docEle.className != contentName) || (owner.isArray(contentName) && contentName.indexOf(docEle.className) == -1)) {
						docEle.style = "display:none;"
					} else
						return docEle.outerHTML;
				});
			} else {
			    console.log("模板2不适用");
			}
		} else {
		    console.log("模板2不适用");
		}
		return "";

	})("body", "", "", ["article-header", "article-content"]);

	/*
	 *模板三
	 */
	owner.template3 = (function(tagName, className, contentTagName, contentId) {
		if (owner.template2.length > 0) return owner.template2;

		var container = owner.getElementByClassNameAndTagName(tagName, className);
		if (container.length > 0) {
			if (owner.isExistsNode(container[0], contentId, "")) {
				console.log("模板3适用", container[0], contentTagName);
				try {
					var author = document.getElementById("sourceName");
					if (author ) {
						owner.author = author.innerText;
					}
					var descriptions = owner.getElementByTagNameAndName("meta", "description");
					if (descriptions && descriptions.length > 0)
						owner.description = descriptions[0].content;
					var title = document.getElementById("mainTitle");
					if (title )
						owner.title = title.innerText;
				} catch (e) {

				}
				return owner.loop1(container[0], contentTagName, function(docEle) {
					console.log(docEle, typeof(contentId));
					if ((typeof(contentId) == "string" && docEle.id != contentId) || (owner.isArray(contentId) && contentId.indexOf(docEle.id) == -1)) {
						docEle.style = "display:none;"
					} else return docEle.outerHTML;
				});
			} else {
			    console.log("模板3不适用");
			}
		} else {
		    console.log("模板3不适用");
		}
		return "";

	})("div", "wrapper", "", ["header", "contentShow"]);

	/*
	 * 获取所有的样式表，extensionList表示样式表的扩展名
	 */
	owner.allStyle = (function(extensionList) {
		var result = "";
		var links = document.getElementsByTagName("link");
		for (var i = 0; i < links.length; i++) {
			if (links[i].getAttribute("href").endWith(extensionList)) {
				result += links[i].outerHTML;
			}
		}
		var styles = document.getElementsByTagName("style");
		console.log(styles);
		for (var i = 0; i < styles.length; i++) {
			result += styles[i].outerHTML;
		}
		return result;
	})(".css");

	/*
	 * 检查是否有style="display: none;，把他去掉
	 * <p style="display: none;">记者：你觉得走到今天这一步，是为什么？</p>
	 */
	owner.showHidden = function() {

	}

	owner.addImgHost = function(hostName) {
		var imgs = document.getElementsByTagName("img");
		for (var i = 0; i < imgs.length; i++) {
			if (!(imgs[i].getAttribute("src").startsWith("http") || imgs[i].getAttribute("src").startsWith("https"))) {
				imgs[i].src = hostName + imgs[i].getAttribute("src");
			}
		}
	}

	owner.template4 = (function() {
	    if (owner.template3.length > 0) return owner.template3;

		var container = document.getElementsByTagName("html")[0];
		if (container) {
			var rgExp = /min-height:.+?[;"]/g;
			return container.outerHTML.replace(rgExp,"");
		} else {
		    console.log("模板不适用");
		}
		return "";
	})();

    TagsayAndroid.setTemplate(owner.template4,owner.allStyle, owner.title, owner.author);

})();