/*
 * 知乎内容提取类
 */
(function() {

    var owner = {};
	owner.isArray = function(obj) {
		return Object.prototype.toString.call(obj) === '[object Array]';
	};

	String.prototype.endWith = function(endStr) {
		console.log(endStr);
		if (Object.prototype.toString.call(endStr) === '[object Array]') {
			for (var i = 0; i < endStr.length; i++) {
				var endstring = endStr[i];
				var d = this.length - endstring.length;
				return (d >= 0 && this.lastIndexOf(endstring) == d);
			}
		} else {
			var d = this.length - endStr.length;
			return (d >= 0 && this.lastIndexOf(endStr) == d);
		}
	};

	/*
     * 获取所有的样式表，extensionList表示样式表的扩展名
     */
	owner.allStyle = (function(extensionList) {
		var result = "";
		var links = document.getElementsByTagName("link");
		for (var i = 0; i < links.length; i++) {
			if (links[i].getAttribute("href") && links[i].getAttribute("href").endWith(extensionList)) {
				result += links[i].outerHTML;
			}
		}
		var styles = document.getElementsByTagName("style");
		console.log(styles);
		for (var i = 0; i < styles.length; i++) {
			result += styles[i].outerHTML;
		}
		return result;
	})(".css");

	owner.specifyJs = (function(fileNams) {
		var result = "";
		var scriptList = document.getElementsByTagName("script");
		for (var i = 0; i < scriptList.length; i++) {
			if (scriptList[i].getAttribute("src") && scriptList[i].getAttribute("src").endWith(fileNams)) {
				result += scriptList[i].outerHTML;
			}
		}
		return result;
	})(["vendor.ff76fbae.js"]);

	/*
     * 使用tagName、className双重检索。
     */
	owner.getElementByClassNameAndTagName = function(tagName, className) {
		var tags = document.getElementsByTagName(tagName);
		var tagArr = [];
		for (var i = 0; i < tags.length; i++) {

			if (tags[i].className == className || className.length == 0) {
				tagArr[tagArr.length] = tags[i];
			}
		}
		return tagArr;
	};

	/*
     * 使用tagName、name双重检索。
     */
	owner.getElementByTagNameAndName = function(tagName, name) {
		var tags = document.getElementsByTagName(tagName);
		var tagArr = [];
		for (var i = 0; i < tags.length; i++) {
			if (tags[i].name == name || name.length == 0) {
				tagArr[tagArr.length] = tags[i];
			}
		}
		return tagArr;
	};

	/*文章标题*/
	owner.title = "";
	/*文章描述*/
	owner.description = "";
	/*文章作者*/
	owner.author = "";

	/*
     * 遍历documentNode下所有TagName，找到以后调用callback
     */
	owner.loop1 = function(documentNode, tagName, callback) {
		var tags = typeof(tagName) == "string" && tagName.length > 0 ? [tagName] : tagName;
		var result = "";
		var childs = documentNode.childNodes;
		for (var i = 0; i < childs.length; i++) {
			if (childs[i].nodeType != 1) continue;
			if (childs[i].nodeType == 1 && (tagName.length == 0 || tagName.indexOf(childs[i].tagName.toLowerCase()) != -1)) {
				if (typeof(callback) == "function") {
					var finded = callback(childs[i]);
					if (finded) result += finded;
				}
			}
		}
		return result;
	};
	/*
     * 判断这个节点下是否存在指定属性的节点
     */
	owner.isExistsNode = function(pNode, idName, className) {
		var childs = pNode.childNodes;
		for (var i = 0; i < childs.length; i++) {
			if (childs[i].nodeType != 1) continue;
			if ((typeof(idName) == "string" && idName.length > 0) || owner.isArray(idName)) {
				var idNames = typeof(idName) == "string" ? [idName] : idName;
				for (var j = 0; j < idNames.length; j++) {
					if (typeof(childs[i].id) != "undefined" && childs[i].id.toLowerCase() == idNames[j]) return true;
				}
			}
			if ((typeof(className) == "string" && className.length > 0) || owner.isArray(className)) {
				var classNames = typeof(className) == "string" ? [className] : className;
				for (var j = 0; j < classNames.length; j++) {
					if (typeof(childs[i].className) != "undefined" && childs[i].className.toLowerCase() == classNames[j]) return true;
				}
			}
		}
		return false;
	};

	/*
     * 提取标题
     */
	owner.extractTitle = function(titleHtml) {
		var platformName = "- 知乎";
		var platformAddress = "www.yidianzixun.com";
		var result = titleHtml.replace(platformName, "");
		return result.replace(platformAddress, "");
	};
	owner.addImgHost = function() {
		var imgs = document.getElementsByTagName("img");
		for (var i = 0; i < imgs.length; i++) {
			if (! (imgs[i].getAttribute("src").startsWith("http") || imgs[i].getAttribute("src").startsWith("https"))) {
				if (imgs[i].getAttribute("data-actualsrc")) imgs[i].src = imgs[i].getAttribute("data-actualsrc");
			}
		}
	};

	/*
     * 模板一，专栏类型
     */
	owner.template1 = (function(tagName, className, contentTagName, contentName) {
		var container = owner.getElementByClassNameAndTagName(tagName, className);
		console.log(container);
		if (container.length > 0) {
			if (owner.isExistsNode(container[0], "", contentName)) {
				console.log("模板1适用");
				owner.addImgHost();
				try {
					var author = document.getElementsByClassName("author name ng-binding");
					if (author && author.length > 0) {
						owner.author = author[0].innerText;
					}
					var descriptions = owner.getElementByTagNameAndName("meta", "description");
					if (descriptions && descriptions.length > 0) owner.description = descriptions[0].content;
					var titles = document.getElementsByTagName("title");
					if (titles && titles.length > 0) owner.title = owner.extractTitle(titles[0].innerText);
				} catch(err) {
                }
				return owner.loop1(container[0], contentTagName,
				function(docEle) {
					console.log(docEle.nodeType, docEle.tagName);
					if (docEle.tagName.toLocaleLowerCase() == contentTagName[0]) return docEle.outerHTML;
					if ((typeof(contentName) == "string" && docEle.className && docEle.className != contentName) || (owner.isArray(contentName) && contentName.indexOf(docEle.className) == -1)) {
						docEle.style = "display:none;"
					} else return docEle.outerHTML;
				});
			}
		} else {
		    console.log("模板1不适用");
		}
		return "";
	})("article", "entry", ["header", "section"], "entry-content ng-binding ng-scope");

	/*
     *模板二，问答类型
     */
	owner.template2 = (function(tagName, className, contentTagName, contentId) {
		if (owner.template1.length > 0) return owner.template1;
		/*显示所有内容*/
		function showAll() {
			var times = 0;
			while (true) {
				var loadMores = document.getElementsByClassName("Button Button--weak Button--large");
				if (loadMores) {
					for (var i = 0; i < loadMores.length; i++) {
						loadMores[i].click();
					}
				}

				var readMoreTags = document.getElementsByClassName("Button AnswerItem-expandButton Button--large");
				for (var i = 0; i < readMoreTags.length; i++) {
					readMoreTags[i].click();
				}
				times++;
				if (readMoreTags.length == 0 || times > 10) break;
			}
		}

		function isExistsNode(pNode) {
			var childs = pNode.childNodes;
			for (var i = 0; i < childs.length; i++) {
				if (childs[i].nodeType != 1) continue;
				if (childs[i].getAttribute("itemType")) return [childs[i]];
			}
			return null;
		};

		var container = owner.getElementByClassNameAndTagName(tagName, className);
		if (container.length > 0) {
			if (container = isExistsNode(container[0])) {
				console.log("模板2适用", container[0], contentTagName);
				showAll();
				owner.addImgHost();
				try {
					var author = document.getElementsByClassName("User-name");
					if (author && author.length > 0) {
						owner.author = author[0].innerText;
					}
					var descriptions = owner.getElementByTagNameAndName("meta", "description");
					if (descriptions && descriptions.length > 0) owner.description = descriptions[0].content;
					var titles = document.getElementsByTagName("title");
					if (titles && titles.length > 0) owner.title = owner.extractTitle(titles[0].innerText);
				} catch(e) {
                }
				return owner.loop1(container[0], contentTagName,
				function(docEle) {
					console.log(docEle, typeof(contentId));
					if ((docEle.className && docEle.className == "QuestionHeader") || (docEle.getAttribute("data-reactid"))) {
						return docEle.outerHTML;
					}
					return "";
				});
			} else {
			    console.log("模板2不适用");
			}
		} else {
		    console.log("模板2不适用");
		}
		return "";

	})("main", "AppMain", "div", "");

	owner.template3 = (function() {
	    if (owner.template2.length > 0) return owner.template2;

		var container = document.getElementsByTagName("html")[0];
		if (container) {
			var rgExp = /min-height:.+?[;"]/g;
			return container.outerHTML.replace(rgExp,"");
		} else {
		    console.log("模板不适用");
		}
		return "";
	})();

    TagsayAndroid.setTemplate(owner.template3,owner.allStyle, owner.title, owner.author);
})();

